﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HeuristicLab.Services.Optimization.Billing.Model {
  public class ContactInformation {
    public long Id { get; set; }
    public string OrganizationName { get; set; }
    public string Street { get; set; }
    public string City { get; set; }
    public string State { get; set; }
    public string PostalCode { get; set; }
    public string LastName { get; set; }
    public string FirstName { get; set; }
    public string Email { get; set; }
  }

  public enum PaymentMethod {
    Cheque,
    Visa,
    MasterCard,
    PayPal,
    Diners
  }

  public class Product {
    public long Id { get; set; }
    public string Name { get; set; }
    public string Description { get; set; }
    public string ProductType { get; set; }
    public double Price { get; set; }
  }

  public class User {
  }

  public enum OrderState {
    Created,
    Active,
    Suspended,
    Overdue,
    Finished
  }

  public class Order {
    public long Id { get; set; }
    public User User { get; set; }
    public string BillingType { get; set; }
    public OrderState State { get; set; }
    public string BillingPeriod { get; set; }
    public DateTime ActiveSince { get; set; }
    public DateTime ActiveUntil { get; set; }
    public IList<Invoice> Invoices { get; set; }
  }

  public class OrderLine {
    public long Id { get; set; }
    public Order Order { get; set; }
    public Product Product { get; set; }
    public int Quantity { get; set; }
    public double ProductPrice { get; set; }
  }

  public class Invoice {
    public long Id { get; set; }
    public User User { get; set; }
    public DateTime Due { get; set; }
    public string Status { get; set; }
    public string InvoiceDocument { get; set; }
    public Order Order { get; set; }
  }

  public class InvoiceLine {
    public long Id { get; set; }
    public Invoice Invoice { get; set; }
    public Product Product { get; set; }
    public int Quantity { get; set; }
    public double ProductPrice { get; set; }
  }


}
